import * as MC from "@minecraft/server";

MC.world.afterEvents.playerInteractWithBlock.subscribe((eventData) => {
  const block = eventData.block;
  if (block) {
    const item = eventData.itemStack;
    let player = eventData.player
    let randomIndex = `${Math.floor(Math.random()*10000)}`;
    if (item.typeId == "mhqstudios:dollybe.dolly" && item.getLore().length == 0) {
      let playerInventory = player.getComponent("minecraft:inventory").container
      item.setLore([`${block.typeId}.${randomIndex}`]);
      playerInventory.setItem(player.selectedSlot, item);
      player.runCommandAsync(`structure save ${block.typeId}.${randomIndex}_dollybe ${block.location.x} ${block.location.y} ${block.location.z} ${block.location.x} ${block.location.y} ${block.location.z}`);
      player.runCommandAsync(`setblock ${block.location.x} ${block.location.y} ${block.location.z} minecraft:air`);
      player.addTag(`${block.typeId}.${randomIndex}`);
    }
  }
});
MC.world.afterEvents.itemUse.subscribe((data) => {
  let player = data.source,
  item = data.itemStack;
  let playerInventory = player.getComponent("minecraft:inventory").container;
  if (item.typeId == "mhqstudios:dollybe.dolly") {
    if (item.getLore().length > 0) {
      let newItem = item.clone()
      player.runCommandAsync(`structure load ${item.getLore()[0]}_dollybe ${player.location.x} ${player.location.y} ${player.location.z}`);
      newItem.setLore([]);
      playerInventory.setItem(player.selectedSlot, newItem);
      player.removeTag(`${item.getLore()[0]}`);
    }
  }
});